CREATE VIEW V_Collected_Playlists_v2
AS
SELECT
  On_Demand_Playlists.Pandora_Id,
  On_Demand_Playlists.Type,
  On_Demand_Playlists.Version,
  On_Demand_Playlists.Listner_Id,
  On_Demand_Playlists.Listner_Token,
  On_Demand_Playlists.Name,
  On_Demand_Playlists.Description,
  On_Demand_Playlists.Time_Created,
  On_Demand_Playlists.Is_Secret,
  On_Demand_Playlists.Total_Tracks AS Track_Count,
  On_Demand_Playlists.Is_Private,
  On_Demand_Playlists.Share_Url_Path,
  IFNULL(On_Demand_Playlists.Local_Icon_Url, On_Demand_Playlists.Artwork_Url_Path) AS Icon_Url,
  On_Demand_Playlists.Linked_Type,
  On_Demand_Playlists.linkedSourceId,
  On_Demand_Playlists.Duration,
  On_Demand_Playlists.Time_Last_Updated AS Last_Updated,
  On_Demand_Playlists.Playlist_Unlock_Status,
  On_Demand_Playlists.Is_Transient,
  Collected_Items.Added_Time
FROM Collected_Items
JOIN On_Demand_Playlists ON (Collected_Items.Pandora_Id = On_Demand_Playlists.Pandora_Id)