SELECT
    Now_Playing_Queue.Pandora_Id as Pandora_Id, Now_Playing_Queue.Type as Type, Now_Playing_Queue.Position as Position
FROM Now_Playing_Queue
LEFT JOIN On_Demand_Tracks ON (Now_Playing_Queue.Pandora_Id = On_Demand_Tracks.Pandora_Id)
WHERE On_Demand_Tracks.Pandora_Id ISNULL AND Now_Playing_Queue.Type ='TR'
UNION
SELECT
    Now_Playing_Queue.Pandora_Id as Pandora_Id ,Now_Playing_Queue.Type as Type, Now_Playing_Queue.Position as Position
FROM Now_Playing_Queue
LEFT JOIN On_Demand_Playlists ON (Now_Playing_Queue.Pandora_Id = On_Demand_Playlists.Pandora_Id)
WHERE On_Demand_Playlists.Pandora_Id ISNULL AND Now_Playing_Queue.Type ='PL'
UNION
SELECT
    Now_Playing_Queue.Pandora_Id as Pandora_Id, Now_Playing_Queue.Type as Type, Now_Playing_Queue.Position as Position
FROM Now_Playing_Queue
LEFT JOIN Albums ON (Now_Playing_Queue.Pandora_Id = Albums.Pandora_Id)
WHERE Albums.Pandora_Id ISNULL AND Now_Playing_Queue.Type ='AL'
UNION
SELECT
    Now_Playing_Queue.Pandora_Id as Pandora_Id, Now_Playing_Queue.Type as Type, Now_Playing_Queue.Position as Position
FROM Now_Playing_Queue
LEFT JOIN stations ON (Now_Playing_Queue.Pandora_Id = stations.Pandora_Id)
WHERE stations.Pandora_Id ISNULL AND Now_Playing_Queue.Type ='ST'