SELECT V_On_Demand_Tracks_V2.Pandora_Id AS Pandora_Id,
  V_On_Demand_Tracks_V2.Type AS Type,
  IFNULL(Track_Details.Scope, V_On_Demand_Tracks_V2.Scope) AS Scope,
  V_On_Demand_Tracks_V2.Name AS Name,
  V_On_Demand_Tracks_V2.Sortable_Name AS Sortable_Name,
  V_On_Demand_Tracks_V2.Duration AS Duration,
  V_On_Demand_Tracks_V2.Track_Number AS Track_Number,
  V_On_Demand_Tracks_V2.Explicitness AS Explicitness,
  V_On_Demand_Tracks_V2.Has_Interactive AS Has_Interactive,
  V_On_Demand_Tracks_V2.Has_Offline AS Has_Offline,
  V_On_Demand_Tracks_V2.Has_Radio_Rights AS Has_Radio_Rights,
  V_On_Demand_Tracks_V2.Expiration_Time AS Expiration_Time,
  V_On_Demand_Tracks_V2.Album_Pandora_Id AS Album_Pandora_Id,
  V_On_Demand_Tracks_V2.Artist_Pandora_Id AS Artist_Pandora_Id,
  V_On_Demand_Tracks_V2.Share_Url_Path AS Share_Url_Path,
  V_On_Demand_Tracks_V2.Artist_Name AS Artist_Name,
  V_On_Demand_Tracks_V2.Last_Modified AS Last_Modified,
  V_On_Demand_Tracks_V2.Last_Updated AS Last_Updated,
  V_On_Demand_Tracks_V2.Has_Radio As Has_Radio,
  V_On_Demand_Tracks_V2.Icon_Url As Icon_Url,
  V_On_Demand_Tracks_V2.Icon_Dominant_Color As Icon_Dominant_Color,
  Track_Details.Track_Tags AS Track_Tags,
  Track_Details.Copyright AS Copyright,
  Track_Details.Sound_Recording_Copyright AS Sound_Recording_Copyright,
  Track_Details.Lyric_Id AS Lyric_Id,
  Track_Details.Lyric_Snippet AS Lyric_Snippet,
  Track_Details.Lyric_Credits AS Lyric_Credits,
  Track_Details.Clean_Lyric_Id AS Clean_Lyric_Id,
  Track_Details.Clean_Lyric_Snippet AS Clean_Lyric_Snippet,
  Track_Details.Clean_Lyric_Credits AS Clean_Lyric_Credits,
  Track_Details.Share_Url_Path AS Details_Share_Url_Path
FROM V_On_Demand_Tracks_V2
JOIN Track_Details ON (V_On_Demand_Tracks_V2.Pandora_Id = Track_Details.Pandora_Id)
WHERE V_On_Demand_Tracks_V2.Pandora_Id = ?